import pyb
from pyb import Pin
import network
import usocket as socket

get_in = Pin(Pin.board.D3, Pin.IN)
get_out = Pin(Pin.board.D4, Pin.OUT)
get_out.value(0)

SSID = "ST67_fat_2.4G"
PASS = "0988719859"
HOST = "ideaschain.com.tw"
API_URL = "iiot.ideaschain.com.tw"
DEVICE_KEY = "w8fkW3waHH3ZPXe5UqVz"

def wifi(): 
	try:
		print("connecting to wifi")
		wlan = network.WLAN()
		wlan.connect(SSID, PASS)

	except:
		print("Wifi module initial error, reconnecting......")
		pyb.delay(1000)
		wifi()

wifi()
print("Wi-Fi connecting")

param_data = "{\n \"PIR\": \"1\"\n}"
param_lenth = str(len(param_data))

addr = socket.getaddrinfo(HOST, 80)[0][-1]
print(addr)

request_str = """\
POST /api/v1/"""+DEVICE_KEY+"""/telemetry HTTP/1.1\r
Content-Type: application/json\r
Content-Length: """+param_lenth+"""\r
Host: """+API_URL+"""\r
\r\n"""+param_data

print(request_str)


def go(): 
	try:
		s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		print("connecting to server")
		s.connect(addr)
		pyb.delay(1000)
		print("server is connected")
		get_out.value(1)
		s.send(bytes(request_str, 'utf8'))
		print("send done")
		get_out.value(0)
		s.close()
	except:
		print("except")
		pyb.delay(1000)

def PIR_status_upload():
	try: 
		if get_in.value() == 1:
			data = 1
			print(data)
			get_out.value(1)
			go()
			
		else:
			data = 0
			print(data)
			get_out.value(0)

	except:
		PIR_status_upload()

while True:
	PIR_status_upload()
	pyb.delay(1000)
